controllers/CiclistaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Ciclista;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * CiclistaController implements the CRUD actions for Ciclista model.
 */
class CiclistaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Ciclista models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Ciclista model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Ciclista model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Ciclista();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->dorsal]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Ciclista model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->dorsal]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Ciclista model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Ciclista model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Ciclista the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Ciclista::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\EntryForm;
use app\models\Ciclista;
use yii\data\Pagination;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller {
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }
    
    public function actionConsulta1(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 1 con active record",
            "enunciado" => "listar las edades de los ciclistas repetidos",
            "sql" => "Select distinct edad from ciclista",
            
        ]);
}
    public function actionConsulta2(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct()->where("nomequipo = 'Artiach'" ),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 2 con active record",
            "enunciado" => "listar las edades de los ciclistas de artiach",
            "sql" => "Select distinct edad from ciclista where nombre = 'artiach'",
            
        ]);
}   
     public function actionConsulta3(){
        
        $dataprovider = new ActiveDataProvider([
            
           'query' => Ciclista::find()->select("edad")->distinct()->where("nomequipo = 'Artiach' or nomequipo = 'Amore Vita'" ),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 3 con active record",
            "enunciado" => "listar las edades de los ciclistas de Artiach o de Amore Vita",
            "sql" => "Select distinct edad from ciclista where nomequipos = 'Amore Vita or nomequipo = 'Artiach'",
            
        ]);
} 
    public function actionConsulta4(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("dorsal")->distinct()->where("edad < 25 or edad > 30"),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['dorsal'],
            "titulo" => "Consulta 4 con active record",
            "enunciado" => "listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql" => "Select distinct dorsal from ciclista where edad < 25 or edad > 30",
            
        ]);
} 
    public function actionConsulta5(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("dorsal")->distinct()->where("edad between 28 and 32 and nombre = 'Banesto'"),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['dorsal'],
            "titulo" => "Consulta 5 con active record",
            "enunciado" => "listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto ",
            "sql" => "Select distinct dorsal from ciclista where edad between 28 and 32 and nomequipo = 'Banesto'",
            
        ]);
} 
    public function actionConsulta6(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("nombre")->distinct()->where("CHAR_LENGTH(nombre) > 8"),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['nombre'],
            "titulo" => "Consulta 6 con active record",
            "enunciado" => "Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8",
            "sql" => "Select distinct nombre from ciclista where CHAR_LENGTH(nombre) > 8",
            
        ]);
} 
    public function actionConsulta7(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("nombre as nombre_mayusculas,dorsal")->distinct().upper(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['nombre','dorsal'],
            "titulo" => "Consulta 7 con active record",
            "enunciado" => "lístame el nombre y el dorsal de todos los ciclistas mostrando un campo nuevo denominado nombre mayúsculas que debe mostrar el nombre en mayúsculas",
            "sql" => "select upper(nombre) as nombre_mayusculas, dorsal  from ciclista;",
            
        ]);
} 
    public function actionConsulta8(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("resultado",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 1 con active record",
            "enunciado" => "listar las edades de los ciclistas repetidos",
            "sql" => "Select distinct edad from ciclista",
            
        ]);
} 
    public function actionConsulta9(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("consulta1",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 1 con active record",
            "enunciado" => "listar las edades de los ciclistas repetidos",
            "sql" => "Select distinct edad from ciclista",
            
        ]);
} 
    public function actionConsulta10(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("consulta1",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 1 con active record",
            "enunciado" => "listar las edades de los ciclistas repetidos",
            "sql" => "Select distinct edad from ciclista",
            
        ]);
} 
    public function actionConsulta11(){
        
        $dataprovider = new ActiveDataProvider([
            
            'query' => Ciclista::find()->select("edad")->distinct(),
            'pagination' => [
                'pagesize' => 5,
            ]
        ]);
        
       
    
        return $this->render("consulta1",[
            "resultados" => $dataprovider,
            "campos" => ['edad'],
            "titulo" => "Consulta 1 con active record",
            "enunciado" => "listar las edades de los ciclistas repetidos",
            "sql" => "Select distinct edad from ciclista",
            
        ]);
} 

    /** 
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }
            
        
        public function actionEntry() {
            

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */
use yii\helpers\Html;

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <h1><b>Consutas de seleccion<b/></h1>
        <h2><i>Módulo 2 - unidad 3</i></h2> <br><br><br>

  <div class="d-flex justify-content-center">
   <div class="row">
    <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 1</h2>
        <p>listar las edades de los ciclistas (sin repetidos)</p>
      <?= Html::a('Active Record', ['/site/consulta1'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?> <br><br>
        </div>
    </div>
    <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 2</h2>
        <p>listar las edades de los ciclistas de Artiach</p>
      <?= Html::a('Active Record', ['/site/consulta2'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>        <br><br>
      </div>
    </div>
    <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 3</h2>
        <p>listar las edades de los ciclistas de Artiach o de Amore Vita</p>
            <?= Html::a('Active Record', ['/site/consulta3'], ['class' => 'btn btn-primary']) ?>
            <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>        <br><br>
        </div>
    </div>
      <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 4</h2>
        <p>listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30</p>
            <?= Html::a('Active Record', ['/site/consulta4'], ['class' => 'btn btn-primary']) ?>
            <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>        <br><br>
        </div>
    </div>
     <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 5</h2>
        <p>listar los dorsales de los ciclistas cuya edad esté entre 28 y 32 y además que sólo sean de Banesto
</p>
      <?= Html::a('Active Record', ['/site/consulta5'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>        <br><br>
      </div>
    </div>
     <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 6</h2>
        <p>Indícame el nombre de los ciclistas que el número de caracteres del nombre sea mayor que 8</p>
      <?= Html::a('Active Record', ['/site/consulta6'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>        <br><br>
      </div>
    </div>
     <div class="col-sm-4">
        <div class="thumbnail">
        <h2>Consulta 7</h2>
        <p>lístame el nombre y el dorsal de todos los ciclistas mostrando un campo nuevo denominado nombre mayúsculas que debe mostrar el nombre en mayúsculas
</p>
      <?= Html::a('Active Record', ['/site/consulta7'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>         <br><br>
      </div>
    </div>
      <div class="col-sm-4">
       <div class="thumbnail">
        <h2>Consulta 8</h2>
        <p>Listar todos los ciclistas que han ganado el maillot MGE (amarillo) en alguna etapa</p>
      <?= Html::a('Active Record', ['/site/consulta8'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>         <br><br>
      </div>
      </div>
     <div class="col-sm-4">
       <div class="thumbnail">
        <h2>Consulta 9</h2>
        <p>Listar el nombre de los puertos cuya altura sea mayor de 1500</p>
      <?= Html::a('Active Record', ['/site/consulta9'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', [''], ['class' => 'btn btn-default']) ?>          <br><br>
      </div>
    </div>
     <div class="col-sm-4">
       <div class="thumbnail">
        <h2>Consulta 10</h2>
        <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura esté entre 1800 y 3000</p>
      <?= Html::a('Active Record', ['/site/consulta10'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', ['/ciclista/index'], ['class' => 'btn btn-default']) ?>          <br><br>
      </div>
    </div>
    <div class="col-sm-4">
       <div class="thumbnail">
        <h2>Consulta 11</h2>
        <p>Listar el dorsal de los ciclistas que hayan ganado algún puerto cuya pendiente sea mayor que 8 y cuya altura esté entre 1800 y 3000</p>
      <?= Html::a('Active Record', ['/site/consulta11'], ['class' => 'btn btn-primary']) ?>
      <?= Html::a('DAO', ['/ciclista/index'], ['class' => 'btn btn-default']) ?>          <br><br>
      </div>
    </div>
    </div>
</div>

views/site/resultado.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\GridView;
?>


<h1> <?= $titulo ?> </h1>     
<h3><i> <?= $enunciado ?> </i></h2>
    
   <h4> <?= $sql ?> </h3>


<?php 
    use \yii\widgets\Pjax;
    Pjax::begin(); // <-- Instancia del Pjax ?>
	<?= GridView::widget([
		'dataProvider' => $resultados,
		'columns' => $campos
	]); ?>
<?php Pjax::end(); ?>